> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nimbleway.com/llms.txt
> Use this file to discover all available pages before exploring further.

# SERP Batch



## OpenAPI

````yaml /api-reference/openapi.json post /v2/serp/batch
openapi: 3.1.0
info:
  title: Nimble SDK
  version: 1.0.0
  description: The AI-Native SDK for Real-Time Web Data at scale
servers:
  - url: https://sdk.nimbleway.com
security: []
paths:
  /v2/serp/batch:
    post:
      tags:
        - SERP
      summary: SERP Batch
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SerpBatchPayload'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SerpBatchResponse'
          description: Batch created successfully
      security:
        - BearerAuth: []
components:
  schemas:
    SerpBatchPayload:
      properties:
        inputs:
          description: >-
            Array of SERP requests. Each object can include search parameters
            and async/storage settings.
          items:
            allOf:
              - properties:
                  country:
                    description: >-
                      ISO Alpha-2 country code used to access the target search
                      engine (e.g. US, DE, GB).
                    examples:
                      - US
                    type: string
                  device:
                    description: Device type used for the search request.
                    enum:
                      - desktop
                      - mobile
                    examples:
                      - desktop
                    type: string
                  domain:
                    default: com
                    description: >-
                      Top-level domain for the search engine (e.g. "com",
                      "co.uk", "de").
                    examples:
                      - com
                    type: string
                  locale:
                    description: Locale used for the search request.
                    examples:
                      - en
                    type: string
                  location:
                    description: >-
                      Geo-location for the search (canonical Google location
                      name).
                    examples:
                      - New York, New York, United States
                    type: string
                  num_results:
                    description: Number of results to return (1–100).
                    examples:
                      - 10
                    maximum: 100
                    minimum: 1
                    type: integer
                  page:
                    description: The result page number for pagination.
                    examples:
                      - 1
                    maximum: 9007199254740991
                    minimum: 1
                    type: integer
                  parse:
                    default: true
                    description: >-
                      When true, the SERP response is parsed into structured
                      JSON.
                    examples:
                      - true
                    type: boolean
                  query:
                    description: The search keyword or phrase to query.
                    examples:
                      - nimble web data
                    type: string
                  render:
                    default: false
                    description: Whether to render the page in a browser before extracting.
                    examples:
                      - false
                    type: boolean
                  search_engine:
                    description: The search engine to query.
                    enum:
                      - google_search
                      - google_sge
                      - google_aio
                      - google_maps_search
                      - google_maps_reviews
                      - google_maps_place
                      - google_news
                      - google_images
                      - bing_search
                      - yandex_search
                    examples:
                      - google_search
                    type: string
                  show_hidden_results:
                    description: >-
                      When true, disables Google result filtering (filter=0) so
                      omitted/duplicate and highly similar pages are also
                      returned. Applies to Google search engines.
                    examples:
                      - false
                    type: boolean
                type: object
              - properties:
                  callback_url:
                    description: URL to call back when async operation completes
                    examples:
                      - https://example.com/webhook/callback
                    type: string
                  storage_compress:
                    description: Whether to compress stored data
                    examples:
                      - true
                    type: boolean
                  storage_object_name:
                    description: Custom name for the stored object
                    examples:
                      - result-2024-01-15.json
                    type: string
                  storage_type:
                    description: Type of storage to use for results
                    examples:
                      - s3
                    type: string
                  storage_url:
                    description: URL for storage location
                    examples:
                      - s3://bucket-name/path/to/object
                    type: string
                type: object
          minItems: 1
          type: array
        shared_inputs:
          allOf:
            - properties:
                country:
                  description: >-
                    ISO Alpha-2 country code used to access the target search
                    engine (e.g. US, DE, GB).
                  examples:
                    - US
                  type: string
                device:
                  description: Device type used for the search request.
                  enum:
                    - desktop
                    - mobile
                  examples:
                    - desktop
                  type: string
                domain:
                  default: com
                  description: >-
                    Top-level domain for the search engine (e.g. "com", "co.uk",
                    "de").
                  examples:
                    - com
                  type: string
                locale:
                  description: Locale used for the search request.
                  examples:
                    - en
                  type: string
                location:
                  description: >-
                    Geo-location for the search (canonical Google location
                    name).
                  examples:
                    - New York, New York, United States
                  type: string
                num_results:
                  description: Number of results to return (1–100).
                  examples:
                    - 10
                  maximum: 100
                  minimum: 1
                  type: integer
                page:
                  description: The result page number for pagination.
                  examples:
                    - 1
                  maximum: 9007199254740991
                  minimum: 1
                  type: integer
                parse:
                  default: true
                  description: When true, the SERP response is parsed into structured JSON.
                  examples:
                    - true
                  type: boolean
                query:
                  description: The search keyword or phrase to query.
                  examples:
                    - nimble web data
                  type: string
                render:
                  default: false
                  description: Whether to render the page in a browser before extracting.
                  examples:
                    - false
                  type: boolean
                search_engine:
                  description: The search engine to query.
                  enum:
                    - google_search
                    - google_sge
                    - google_aio
                    - google_maps_search
                    - google_maps_reviews
                    - google_maps_place
                    - google_news
                    - google_images
                    - bing_search
                    - yandex_search
                  examples:
                    - google_search
                  type: string
                show_hidden_results:
                  description: >-
                    When true, disables Google result filtering (filter=0) so
                    omitted/duplicate and highly similar pages are also
                    returned. Applies to Google search engines.
                  examples:
                    - false
                  type: boolean
              type: object
            - properties:
                callback_url:
                  description: URL to call back when async operation completes
                  examples:
                    - https://example.com/webhook/callback
                  type: string
                storage_compress:
                  description: Whether to compress stored data
                  examples:
                    - true
                  type: boolean
                storage_object_name:
                  description: Custom name for the stored object
                  examples:
                    - result-2024-01-15.json
                  type: string
                storage_type:
                  description: Type of storage to use for results
                  examples:
                    - s3
                  type: string
                storage_url:
                  description: URL for storage location
                  examples:
                    - s3://bucket-name/path/to/object
                  type: string
              type: object
          description: >-
            Shared parameters applied to the entire batch. Can include search
            parameters and async/storage settings.
      required:
        - inputs
      type: object
    SerpBatchResponse:
      additionalProperties: false
      description: Response when a batch of SERP tasks is created successfully.
      properties:
        batch_id:
          description: Unique identifier for the batch.
          type: string
        batch_size:
          description: Number of tasks in the batch.
          type: number
        tasks:
          description: List of created tasks.
          items:
            additionalProperties: false
            properties:
              _query: {}
              account_name:
                description: Account name that owns the task.
                type: string
              api_type:
                enum:
                  - web
                  - serp
                  - ecommerce
                  - social
                  - media
                  - agent
                  - extract
                  - fast-serp
                  - labs
                type: string
              batch_id:
                anyOf:
                  - type: string
                  - type: 'null'
                description: Batch ID if this task is part of a batch.
                examples:
                  - 4b0a90bf-c951-42e4-95b3-a95a65ba69fc
              created_at:
                description: Timestamp when the task was created.
                examples:
                  - '2024-01-15T10:30:00Z'
                type: string
              download_url:
                anyOf:
                  - format: uri
                    type: string
                  - type: 'null'
                description: URL for downloading the task results.
                examples:
                  - >-
                    https://api.webit.live/api/v2/tasks/123e4567-e89b-12d3-a456-426614174000/results
              error:
                anyOf:
                  - type: string
                  - type: 'null'
                description: Error message if the task failed.
                examples:
                  - Connection timeout
              error_type:
                anyOf:
                  - type: string
                  - type: 'null'
                description: Classification of the error type.
                examples:
                  - timeout_error
              id:
                description: Unique task identifier.
                examples:
                  - 123e4567-e89b-12d3-a456-426614174000
                minLength: 1
                type: string
              input:
                description: Original input data for the task.
              modified_at:
                description: Timestamp when the task was last modified.
                examples:
                  - '2024-01-15T10:35:00Z'
                type: string
              output_url:
                anyOf:
                  - type: string
                  - type: 'null'
                description: Storage location of the output data.
              queue:
                description: Queue name the task was submitted to.
                type: string
              state:
                description: Current state of the task.
                enum:
                  - pending
                  - queued
                  - in_progress
                  - success
                  - error
                examples:
                  - pending
                type: string
              status_code:
                description: HTTP status code from the task execution.
                examples:
                  - 200
                type: number
              status_url:
                description: URL for checking the task status.
                examples:
                  - >-
                    https://api.webit.live/api/v2/tasks/123e4567-e89b-12d3-a456-426614174000
                format: uri
                type: string
            required:
              - id
              - state
              - status_url
              - created_at
              - input
              - _query
            type: object
          type: array
      required:
        - batch_id
        - batch_size
        - tasks
      type: object
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.